#!/bin/sh
#
# This scripts allow you to send status-server packets
# to a radius server (which *MUST* support such packets... FreeRadius 2.x does!)
#
# YOU *MUST* configure your cacti server as a client for 
# a status listener in freeradius (using virtual server is a good idea)
#
# 	client cacti {
#		ipaddr = a.b.c.d
#		secret = is_a_secret
#		require-message-authenticator = no
#	}
#
# This script and its associted cacti templates are freely usable
# and are not controled by any license.
# Feel free to contact for question
# Author: alxgomz@gmail.com
#

RADCLIENT=radclient
FR_STAT_ATTR_NAME='FreeRADIUS-Statistics-Type'

# Check if radclient is installed
if [ ! -x `which $RADCLIENT` ]; then echo "$RADCLIENT is not installed"
	exit 2
fi

# Caught from freeradius example
if [ -z $4 ]; then UDP_PORT=:18120
 else UDP_PORT=":$4"
fi

case $1 in
	auth)
		QTYPE=Authentication
	;;
	acct)
		QTYPE=Accounting
	;;
	*)
		echo "Query type must be one of acct or auth" && exit 1
	;;
esac

echo -e "Message-Authenticator = $3\n$FR_STAT_ATTR_NAME = $QTYPE" |\
 radclient ${2}$UDP_PORT status $3 |\
 sed '1d;s/\ =\ /:/' |\
 tr -d '\n' |\
 tr '\t' ' '

